import type { Options } from 'amqplib/properties';
import type { AMQPPublisherOptions } from './AbstractAmqpPublisher';
import { AbstractAmqpPublisher } from './AbstractAmqpPublisher';
import type { AMQPDependencies, AMQPQueueCreationConfig, AMQPQueueLocator } from './AbstractAmqpService';
export type AmqpQueueMessageOptions = {
    publishOptions: Options.Publish;
};
export declare abstract class AbstractAmqpQueuePublisher<MessagePayloadType extends object> extends AbstractAmqpPublisher<MessagePayloadType, AmqpQueueMessageOptions, AMQPQueueCreationConfig, AMQPQueueLocator> {
    protected readonly queueName: string;
    constructor(dependencies: AMQPDependencies, options: AMQPPublisherOptions<MessagePayloadType, AMQPQueueCreationConfig, AMQPQueueLocator>);
    protected publishInternal(message: Buffer, options: AmqpQueueMessageOptions): void;
    publish(message: MessagePayloadType, options?: AmqpQueueMessageOptions): void;
    protected createMissingEntities(): Promise<void>;
}
