"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AbstractAmqpQueuePublisher = void 0;
const AbstractAmqpPublisher_1 = require("./AbstractAmqpPublisher");
const amqpQueueUtils_1 = require("./utils/amqpQueueUtils");
const NO_PARAMS = {
    publishOptions: {},
};
class AbstractAmqpQueuePublisher extends AbstractAmqpPublisher_1.AbstractAmqpPublisher {
    queueName;
    constructor(dependencies, options) {
        super(dependencies, options);
        if (!options.locatorConfig?.queueName && !options.creationConfig?.queueName) {
            throw new Error('Either locatorConfig or creationConfig must provide queueName');
        }
        this.queueName = options.locatorConfig
            ? options.locatorConfig.queueName
            : options.creationConfig.queueName;
    }
    publishInternal(message, options) {
        this.channel.sendToQueue(this.queueName, message, options.publishOptions);
    }
    publish(message, options = NO_PARAMS) {
        super.publish(message, options);
    }
    createMissingEntities() {
        return (0, amqpQueueUtils_1.ensureAmqpQueue)(this.connection, this.channel, this.creationConfig, this.locatorConfig);
    }
}
exports.AbstractAmqpQueuePublisher = AbstractAmqpQueuePublisher;
//# sourceMappingURL=AbstractAmqpQueuePublisher.js.map