import type { Options } from 'amqplib/properties';
import type { AMQPPublisherOptions } from './AbstractAmqpPublisher';
import { AbstractAmqpPublisher } from './AbstractAmqpPublisher';
import type { AMQPDependencies, AMQPTopicCreationConfig, AMQPTopicLocator, AMQPTopicPublisherConfig } from './AbstractAmqpService';
export type AMQPTopicPublisherOptions<MessagePayloadType extends object> = Omit<AMQPPublisherOptions<MessagePayloadType, AMQPTopicCreationConfig, AMQPTopicLocator>, 'creationConfig'> & {
    exchange: string;
};
export type AmqpTopicMessageOptions = {
    routingKey?: string;
    publishOptions?: Options.Publish;
};
export declare abstract class AbstractAmqpTopicPublisher<MessagePayloadType extends object> extends AbstractAmqpPublisher<MessagePayloadType, AmqpTopicMessageOptions, AMQPTopicPublisherConfig, AMQPTopicPublisherConfig> {
    constructor(dependencies: AMQPDependencies, options: AMQPTopicPublisherOptions<MessagePayloadType>);
    protected publishInternal(message: Buffer, options: Omit<AmqpTopicMessageOptions, 'routingKey'> & {
        routingKey: string;
    }): void;
    protected createMissingEntities(): Promise<void>;
}
