"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AbstractAmqpTopicPublisher = void 0;
const AbstractAmqpPublisher_1 = require("./AbstractAmqpPublisher");
const amqpQueueUtils_1 = require("./utils/amqpQueueUtils");
class AbstractAmqpTopicPublisher extends AbstractAmqpPublisher_1.AbstractAmqpPublisher {
    constructor(dependencies, options) {
        super(dependencies, {
            ...options,
            creationConfig: {
                exchange: options.exchange,
                updateAttributesIfExists: false,
            },
            exchange: options.exchange,
            locatorConfig: undefined,
        });
    }
    publishInternal(message, options) {
        this.channel.publish(this.exchange, options.routingKey, message, options.publishOptions);
    }
    async createMissingEntities() {
        await (0, amqpQueueUtils_1.ensureExchange)(this.connection, this.channel, this.creationConfig, this.locatorConfig);
    }
}
exports.AbstractAmqpTopicPublisher = AbstractAmqpTopicPublisher;
//# sourceMappingURL=AbstractAmqpTopicPublisher.js.map