import type { Either } from '@lokalise/node-core';
import type { MessageInvalidFormatError, MessageValidationError, ParseMessageResult } from '@message-queue-toolkit/core';
import type { Message } from 'amqplib';
import type { ZodType } from 'zod';
import type { AmqpConsumerErrorResolver } from './errors/AmqpConsumerErrorResolver';
export declare const deserializeAmqpMessage: <T extends object>(message: Message, type: ZodType<T>, errorProcessor: AmqpConsumerErrorResolver) => Either<MessageInvalidFormatError | MessageValidationError, ParseMessageResult<T>>;
