import type { DeletionConfig } from '@message-queue-toolkit/core';
import type { Channel, Connection } from 'amqplib';
import type { AMQPQueueCreationConfig, AMQPQueueLocator, AMQPTopicCreationConfig, AMQPTopicLocator, AMQPTopicPublisherConfig } from '../AbstractAmqpService';
export declare function checkQueueExists(connection: Connection, locatorConfig: AMQPQueueLocator): Promise<void>;
export declare function checkExchangeExists(connection: Connection, locatorConfig: AMQPTopicPublisherConfig): Promise<void>;
export declare function ensureAmqpQueue(connection: Connection, channel: Channel, creationConfig?: AMQPQueueCreationConfig, locatorConfig?: AMQPQueueLocator): Promise<void>;
export declare function ensureAmqpTopicSubscription(connection: Connection, channel: Channel, creationConfig?: AMQPTopicCreationConfig, locatorConfig?: AMQPTopicLocator): Promise<void>;
export declare function ensureExchange(connection: Connection, channel: Channel, creationConfig?: AMQPTopicPublisherConfig, locatorConfig?: AMQPTopicPublisherConfig): Promise<void>;
export declare function deleteAmqpQueue(channel: Channel, deletionConfig: DeletionConfig, creationConfig: AMQPQueueCreationConfig): Promise<void>;
